(function (_, kotlin_clikt_clikt, kotlin_kotlin, kotlin_mordant_mordant) {
  'use strict';
  //region block: imports
  var CoreCliktCommand = kotlin_clikt_clikt.$_$.b;
  var VOID = kotlin_kotlin.$_$.f;
  var Unit_instance = kotlin_kotlin.$_$.a4;
  var protoOf = kotlin_kotlin.$_$.q9;
  var classMeta = kotlin_kotlin.$_$.l8;
  var setMetadataFor = kotlin_kotlin.$_$.r9;
  var selfAndAncestors = kotlin_clikt_clikt.$_$.f;
  var mapNotNull = kotlin_kotlin.$_$.wa;
  var firstOrNull = kotlin_kotlin.$_$.ra;
  var Terminal_init_$Create$ = kotlin_mordant_mordant.$_$.g;
  var last = kotlin_kotlin.$_$.va;
  var MultiplatformSystem_instance = kotlin_mordant_mordant.$_$.i;
  var FileNotFound = kotlin_clikt_clikt.$_$.c;
  var Terminal = kotlin_mordant_mordant.$_$.b;
  var Whitespace_NORMAL_getInstance = kotlin_mordant_mordant.$_$.e;
  var Text_init_$Create$ = kotlin_mordant_mordant.$_$.h;
  var AbstractHelpFormatter = kotlin_clikt_clikt.$_$.h;
  var verticalLayout = kotlin_mordant_mordant.$_$.a;
  var charSequenceLength = kotlin_kotlin.$_$.j8;
  var definitionList = kotlin_mordant_mordant.$_$.c;
  var withPadding = kotlin_mordant_mordant.$_$.d;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.y4;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.i;
  var ensureNotNull = kotlin_kotlin.$_$.he;
  var drop = kotlin_kotlin.$_$.gb;
  var plus = kotlin_kotlin.$_$.oe;
  var Whitespace_PRE_WRAP_getInstance = kotlin_mordant_mordant.$_$.f;
  var isBlank = kotlin_kotlin.$_$.mb;
  var replace = kotlin_kotlin.$_$.zb;
  //endregion
  //region block: pre-declaration
  setMetadataFor(CliktCommand, 'CliktCommand', classMeta, CoreCliktCommand);
  setMetadataFor(MordantHelpFormatter, 'MordantHelpFormatter', classMeta, AbstractHelpFormatter);
  //endregion
  function CliktCommand(name) {
    name = name === VOID ? null : name;
    CoreCliktCommand.call(this, name);
    installMordant(this);
  }
  function installMordant(_this__u8e3s4, force) {
    force = force === VOID ? false : force;
    _this__u8e3s4.e1o(installMordant$lambda(force));
  }
  function get_terminal(_this__u8e3s4) {
    // Inline function 'com.github.ajalt.clikt.core.Context.findObject' call
    var key = 'mordant_terminal';
    var tmp = selfAndAncestors(_this__u8e3s4);
    var tmp0_elvis_lhs = firstOrNull(mapNotNull(tmp, _get_terminal_$lambda_5keric(key)));
    var tmp_0;
    if (tmp0_elvis_lhs == null) {
      // Inline function 'kotlin.also' call
      var this_0 = Terminal_init_$Create$();
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.github.ajalt.clikt.core.<get-terminal>.<anonymous>' call
      // Inline function 'kotlin.collections.set' call
      var this_1 = last(selfAndAncestors(_this__u8e3s4)).c1m_1;
      var key_0 = 'mordant_terminal';
      this_1.m2(key_0, this_0);
      tmp_0 = this_0;
    } else {
      tmp_0 = tmp0_elvis_lhs;
    }
    return tmp_0;
  }
  function installMordant$lambda$lambda(it) {
    return new MordantHelpFormatter(it);
  }
  function installMordant$lambda$lambda_0(it) {
    return MultiplatformSystem_instance.i2a(it);
  }
  function installMordant$lambda$lambda_1(it) {
    var tmp0_elvis_lhs = MultiplatformSystem_instance.k2a(it);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      throw new FileNotFound(it);
    } else {
      tmp = tmp0_elvis_lhs;
    }
    return tmp;
  }
  function installMordant$lambda$lambda_2(it) {
    MultiplatformSystem_instance.j2a(it);
    return Unit_instance;
  }
  function installMordant$lambda$lambda_3(context, message, trailingNewline, err) {
    if (trailingNewline) {
      get_terminal(context).i2k(message, VOID, VOID, VOID, VOID, err);
    } else {
      get_terminal(context).g2k(message, VOID, VOID, VOID, VOID, err);
    }
    return Unit_instance;
  }
  function installMordant$lambda($force) {
    return function ($this$configureContext) {
      var tmp;
      if (!$force ? !($this$configureContext.f1o_1 == null) : false) {
        return Unit_instance;
      }
      var tmp_0 = $this$configureContext;
      tmp_0.k1o_1 = installMordant$lambda$lambda;
      var tmp_1 = $this$configureContext;
      tmp_1.s1o_1 = installMordant$lambda$lambda_0;
      var tmp_2 = $this$configureContext;
      tmp_2.n1o_1 = installMordant$lambda$lambda_1;
      var tmp_3 = $this$configureContext;
      tmp_3.v1o_1 = installMordant$lambda$lambda_2;
      var tmp_4 = $this$configureContext;
      tmp_4.u1o_1 = installMordant$lambda$lambda_3;
      return Unit_instance;
    };
  }
  function _get_terminal_$lambda_5keric($key) {
    return function (it) {
      var tmp = it.c1m_1.e2($key);
      return tmp instanceof Terminal ? tmp : null;
    };
  }
  function MordantHelpFormatter$formatHelp$lambda(this$0, $error, $prolog, $epilog, $parameters, $programName) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.y2g(1);
      $this$verticalLayout.v2g(this$0.r1u($error, $prolog, $epilog, $parameters, $programName));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderUsage$lambda($prog, $usageParts) {
    return function ($this$definitionList) {
      $this$definitionList.s2k($prog, Text_init_$Create$($usageParts, Whitespace_NORMAL_getInstance()));
      $this$definitionList.m2k_1 = true;
      $this$definitionList.p2k(1);
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderProlog$lambda($this$withPadding) {
    $this$withPadding.v2i_1 = 2;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderParameters$lambda(this$0, $parameters) {
    return function ($this$definitionList) {
      var _iterator__ex2g4s = this$0.e1w($parameters).m();
      while (_iterator__ex2g4s.n()) {
        var section = _iterator__ex2g4s.o();
        $this$definitionList.s2k(section.y1t_1, section.z1t_1);
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderOptionGroup$lambda($this$withPadding) {
    $this$withPadding.s2i_1 = 1;
    $this$withPadding.v2i_1 = 2;
    $this$withPadding.u2i_1 = 1;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderOptionGroup$lambda_0($markdown, this$0, $options) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.x2g($markdown);
      $this$verticalLayout.x2g(this$0.o1w($options));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$buildParameterList$lambda($rows, this$0) {
    return function ($this$definitionList) {
      $this$definitionList.m2k_1 = true;
      var _iterator__ex2g4s = $rows.m();
      while (_iterator__ex2g4s.n()) {
        var row = _iterator__ex2g4s.o();
        $this$definitionList.t2k(this$0.j1x(row), this$0.k1x(row));
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter(context, requiredOptionMarker, showDefaultValues, showRequiredTag) {
    requiredOptionMarker = requiredOptionMarker === VOID ? null : requiredOptionMarker;
    showDefaultValues = showDefaultValues === VOID ? false : showDefaultValues;
    showRequiredTag = showRequiredTag === VOID ? false : showRequiredTag;
    AbstractHelpFormatter.call(this, context, requiredOptionMarker, showDefaultValues, showRequiredTag);
  }
  protoOf(MordantHelpFormatter).x2l = function () {
    return get_terminal(this.f1u_1).s2d_1;
  };
  protoOf(MordantHelpFormatter).y1n = function (error, prolog, epilog, parameters, programName) {
    var widget = verticalLayout(MordantHelpFormatter$formatHelp$lambda(this, error, prolog, epilog, parameters, programName));
    return get_terminal(this.f1u_1).j2k(widget);
  };
  protoOf(MordantHelpFormatter).t1u = function (parameters, error) {
    return Text_init_$Create$(this.x1u(parameters, error));
  };
  protoOf(MordantHelpFormatter).s1u = function (parameters, programName) {
    var title = this.y2l(this.q1u().e1x());
    var prog = title + ' ' + programName;
    var usageParts = this.b1v(parameters);
    var tmp;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(usageParts) === 0) {
      tmp = Text_init_$Create$(prog, Whitespace_NORMAL_getInstance());
    } else {
      tmp = definitionList(MordantHelpFormatter$renderUsage$lambda(prog, usageParts));
    }
    return tmp;
  };
  protoOf(MordantHelpFormatter).u1u = function (prolog) {
    var tmp = this.z2l(prolog);
    return withPadding(tmp, false, MordantHelpFormatter$renderProlog$lambda);
  };
  protoOf(MordantHelpFormatter).w1u = function (epilog) {
    return this.z2l(epilog);
  };
  protoOf(MordantHelpFormatter).v1u = function (parameters) {
    return definitionList(MordantHelpFormatter$renderParameters$lambda(this, parameters));
  };
  protoOf(MordantHelpFormatter).c1w = function (help, parameters) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(parameters, 10));
    var tmp0_iterator = parameters.m();
    while (tmp0_iterator.n()) {
      var item = tmp0_iterator.o();
      var tmp$ret$0 = this.h1w(item);
      destination.e(tmp$ret$0);
    }
    var options = destination;
    if (help == null)
      return this.o1w(options);
    var tmp = this.z2l(help);
    var markdown = withPadding(tmp, false, MordantHelpFormatter$renderOptionGroup$lambda);
    return verticalLayout(MordantHelpFormatter$renderOptionGroup$lambda_0(markdown, this, options));
  };
  protoOf(MordantHelpFormatter).n1u = function (name) {
    // Inline function 'kotlin.text.lowercase' call
    // Inline function 'kotlin.js.asDynamic' call
    return '<' + name.toLowerCase() + '>';
  };
  protoOf(MordantHelpFormatter).m1w = function (name) {
    return this.x2l().i2d('danger').g26(name);
  };
  protoOf(MordantHelpFormatter).v1w = function (name) {
    return this.x2l().i2d('muted').g26(name);
  };
  protoOf(MordantHelpFormatter).l1u = function (name) {
    return this.x2l().i2d('info').g26(name);
  };
  protoOf(MordantHelpFormatter).o1u = function (name) {
    return this.x2l().i2d('info').g26(name);
  };
  protoOf(MordantHelpFormatter).p1u = function (name) {
    return this.x2l().i2d('info').g26(name);
  };
  protoOf(MordantHelpFormatter).d1w = function (title) {
    return this.x2l().i2d('warning').g26(title);
  };
  protoOf(MordantHelpFormatter).y2l = function (title) {
    return this.x2l().i2d('warning').g26(title);
  };
  protoOf(MordantHelpFormatter).z1u = function (title) {
    return this.x2l().i2d('danger').g26(title);
  };
  protoOf(MordantHelpFormatter).e1v = function (parameter) {
    return this.x2l().i2d('muted').g26(parameter);
  };
  protoOf(MordantHelpFormatter).x1w = function (metavar) {
    return this.x2l().i2d('warning').v29(this.x2l().i2d('muted')).g26(metavar);
  };
  protoOf(MordantHelpFormatter).j1x = function (row) {
    var tmp;
    // Inline function 'kotlin.text.isNullOrEmpty' call
    var this_0 = row.c1u_1;
    // Inline function 'kotlin.contracts.contract' call
    if (this_0 == null ? true : charSequenceLength(this_0) === 0) {
      tmp = '  ';
    } else {
      // Inline function 'kotlin.text.ifEmpty' call
      var this_1 = drop('  ', ensureNotNull(row.c1u_1).length);
      // Inline function 'kotlin.contracts.contract' call
      var tmp_0;
      // Inline function 'kotlin.text.isEmpty' call
      if (charSequenceLength(this_1) === 0) {
        // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderDefinitionTerm.<anonymous>' call
        tmp_0 = ' ';
      } else {
        tmp_0 = this_1;
      }
      var tmp$ret$3 = tmp_0;
      tmp = plus(row.c1u_1, tmp$ret$3);
    }
    var termPrefix = tmp;
    return Text_init_$Create$(termPrefix + row.a1u_1, Whitespace_PRE_WRAP_getInstance());
  };
  protoOf(MordantHelpFormatter).k1x = function (row) {
    return isBlank(row.b1u_1) ? Text_init_$Create$('') : this.z2l(row.b1u_1);
  };
  protoOf(MordantHelpFormatter).o1w = function (rows) {
    return definitionList(MordantHelpFormatter$buildParameterList$lambda(rows, this));
  };
  protoOf(MordantHelpFormatter).z2l = function (text) {
    return Text_init_$Create$(replace(text, '\n\n', '\x85\x85'), Whitespace_NORMAL_getInstance());
  };
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = CliktCommand;
  //endregion
  return _;
}(module.exports, require('./clikt-clikt.js'), require('./kotlin-kotlin-stdlib.js'), require('./mordant-mordant.js')));

//# sourceMappingURL=clikt-clikt-mordant.js.map
